package compiler;

import java.io.DataInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectInputStream;

public class Compiler
{
	public static final int SUCCESS = 0;
	public static final int COMPILE_ERROR = 1;
	public static final int RUNTIME_ERROR = 2;
	public static final int STRING_TYPE_ERROR = 3;
	public static final int CONNECTION_ERROR = 4;
	
	public int compileAndRun(InputStream is, String name)
	{
		ObjectInputStream ois;
		try {
			ois = new ObjectInputStream(is);
		} catch (Exception e) {
			return CONNECTION_ERROR;
		}
		String content;
		try {
			content = ois.readUTF();
		} catch (Exception e) {
			return STRING_TYPE_ERROR;
		}
		
		MemoryClassLoader mcl;
		try {
			mcl = new MemoryClassLoader(name, content);
			Class<RacsJob> job = (Class<RacsJob>) mcl.loadClass(name);
			job.newInstance();
		} catch (Exception e) {
			return COMPILE_ERROR;
		}
		
		
		return SUCCESS;
	}
}