package objectmap;

import java.io.Externalizable;
import java.io.IOException;
import java.io.ObjectInput;
import java.io.ObjectInputStream;
import java.io.ObjectOutput;
import java.io.ObjectOutputStream;

import remote.Versionable;

public class KeyData extends Versionable {
	
	public int repoID;
	public long groupID;
	public int owner;
	public long keyID;
	public int size;
	public int metaRepo;
	
	public KeyData() {}
	
	public KeyData(Integer repo, long groupID, int owner, long keyID, int size, int meta)
	{
		repoID       = repo.intValue();
		this.groupID = groupID;
		this.owner   = owner;
		this.keyID   = keyID;
		this.size    = size;
		metaRepo     = meta;
	}

	@Override
	protected void writeTo(ObjectOutputStream out) throws IOException {
		out.writeLong(groupID);
		out.writeLong(keyID);
		out.writeInt(repoID);
		out.writeInt(size);
		out.writeInt(owner);
		out.writeInt(metaRepo);
	}

	@Override
	protected void readFrom(ObjectInputStream in) throws IOException {
		groupID = in.readLong();
		keyID   = in.readLong();
		repoID  = in.readInt();
		size    = in.readInt();
		owner   = in.readInt();
		metaRepo= in.readInt();
	}

	@Override
	public String getUniqueKey(String key) {
		int sc = ObjectMap.sizeGroup(size);
		return keyID + "-" + sc + "-" + owner + "-" + key;
	}

	@Override
	public String parseUniqueKey(String key) {
		String[] splt = key.split("-");
		return splt[3];
	}
	
}
