package objectmap;

import java.util.Comparator;

import repository.DataReader;

public class PutsTuple implements Comparable<PutsTuple> {

	public static final TupleCompare COMP = new TupleCompare();
	public DataReader data;
	public String key;
	public int sc;
	
	public PutsTuple(DataReader dr, String k)
	{
		data = dr;
		key = k;
		sc = ObjectMap.sizeGroup(dr.size());
	}
	
	@Override
	public int compareTo(PutsTuple o) {
		return sc - o.sc;
	}
	
	public static class TupleCompare implements Comparator<PutsTuple>
	{

		@Override
		public int compare(PutsTuple o1, PutsTuple o2) {
			return o1.key.compareTo(o2.key);
		}
		
	}

}
