package racs;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.HttpURLConnection;

import objectmap.ObjectMap;
import repository.DataReader;

import com.sun.net.httpserver.HttpExchange;
import com.sun.net.httpserver.HttpHandler;

public class RacsHandler implements HttpHandler {

	private ObjectMap omap;
	
	public RacsHandler(ObjectMap omap)
	{
		this.omap = omap;
	}
	
	public RequestData parseHeaders(HttpExchange arg)
	{
		
		try
		{
			RequestData d = new RequestData();
			try
			{
				d.size = Integer.parseInt(arg.getRequestHeaders().getFirst("Content-Length"));
			}
			catch(Exception e)
			{
				
			}
			
			d.key = arg.getRequestURI().getPath();
			d.key = d.key.substring(1, d.key.length());
			return d;
		}
		catch(Exception e)
		{
			return null;
		}
	}
	@Override
	public void handle(HttpExchange arg) throws IOException {
		try
		{
			String method = arg.getRequestMethod();
			long before = System.currentTimeMillis();
			RequestData data = parseHeaders(arg);
			int sc = ObjectMap.sizeGroup(data.size);
			System.out.println(data.key + " c");
			DataReader getData = null;
			if(method.equals("PUT"))
			{
				DataReader dr = new DataReader(arg.getRequestBody(), data.size);
				try {
					omap.put(data.key, dr, null);
				} catch (Exception e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			else if(method.equals("GET"))
			{
				getData = omap.get(data.key);
				
			}
			else if(method.equals("DELETE"))
			{
				//ADD OMAP.REMOVE HERE
			}
			
			arg.getResponseHeaders().add("Content-Type", "text");
			if(getData == null)
			{
				arg.sendResponseHeaders(HttpURLConnection.HTTP_OK, -1);
			}
			else
			{
				arg.sendResponseHeaders(HttpURLConnection.HTTP_OK, getData.size());
				sendData(getData, arg.getResponseBody());
				sc = ObjectMap.sizeGroup(getData.size());
			}
			long after = System.currentTimeMillis();
			RacsTimer.addData(RacsTimer.TOTAL, sc, after-before);
		}
		finally
		{
			arg.close();
		}
		
	}
	
	private void sendData(DataReader dr, OutputStream out) throws IOException
	{
		int readIndex = 0;
		int readLength;
		
		while( (readLength = dr.update(readIndex)) != -1)
		{
			out.write(dr.data, readIndex, readLength);
			readIndex += readLength;
		}
		dr.close();
	}
	
	private class RequestData
	{
		public int size;
		public String key;
	}
}
