package racs;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.Map.Entry;

public class RacsTimer {
	
	static ArrayList<LinkedList<Tuple>> times = new ArrayList<>();
	static ArrayList<String> names = new ArrayList<>();
	
	public static final Integer UPLOAD = 0;
	public static final Integer TOTAL = 1;
	public static final Integer PARITY = 2;
	public static final Integer GET = 3;
	public static final Integer LOCK = 4;
	public static final Integer FREE = 5;
	public static final Integer UNLOCK = 6;
	public static final Integer RECV = 7;
	public static final Integer PARITYC = 8;
	public static final Integer PARITYN = 9;
	
	static
	{
		init();
	}
	
	public static void init()
	{
		times.add(UPLOAD, new LinkedList<Tuple>());
		times.add(TOTAL, new LinkedList<Tuple>());
		times.add(PARITY, new LinkedList<Tuple>());
		times.add(GET, new LinkedList<Tuple>());
		times.add(LOCK, new LinkedList<Tuple>());
		times.add(FREE, new LinkedList<Tuple>());
		times.add(UNLOCK, new LinkedList<Tuple>());
		times.add(RECV, new LinkedList<Tuple>());
		times.add(PARITYC, new LinkedList<Tuple>());
		times.add(PARITYN, new LinkedList<Tuple>());
		
		names.add(UPLOAD, "UPLOAD");
		names.add(TOTAL, "TOTAL");
		names.add(PARITY, "PARITY");
		names.add(GET, "GET");
		names.add(LOCK, "LOCK");
		names.add(FREE, "FREE");
		names.add(UNLOCK, "UNLOCK");
		names.add(RECV, "RECV");
		names.add(PARITYC, "PARITYC");
		names.add(PARITYN, "PARITYN");
	}
	
	
	
	public static void addData(int type, int size, long time)
	{
		Tuple t = new Tuple(size, time);
		LinkedList<Tuple> l = times.get(type);
		synchronized(l)
		{
			l.add(t);
		}
	}
	
	public static void printData()
	{
		int i = 0;
		for(LinkedList<Tuple> l : times)
		{
			HashMap<Integer, Tuple> data = new HashMap<>();
			long sum = 0;
			for(Tuple t : l)
			{
				sum += t.time;
				Tuple tuple = new Tuple(1,t.time);
				Tuple old = data.put(t.sc, tuple);
				if(old != null)
				{
					tuple.sc = old.sc + 1;
					tuple.time += old.time;
				}
			}
			System.out.println(names.get(i) + " Total: " + (sum*1.0)/(1000.0*l.size()) + " Count: " + l.size());
			for(Entry<Integer, Tuple> e : data.entrySet())
			{
				System.out.println("\t" + e.getKey() + ": " + e.getValue().time/(1000.0 * e.getValue().sc) + " Count: " + e.getValue().sc);
			}
			i++;
		}
	}
	
	private static class Tuple
	{
		int sc;
		long time;
		public Tuple(int sc, long time)
		{
			this.sc = sc;
			this.time = time;
		}
	}
}
