package remote;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;

import org.apache.curator.framework.recipes.locks.InterProcessMutex;

public abstract class Freeable<K, V> extends Versionable {
	
	private String remoteGroup;
	private InterProcessMutex lock;
	private long time;
	
	final String getRemoteGroup()
	{
		return remoteGroup;
	}
	
	public final void setRemoteGroup(String group)
	{
		remoteGroup = group;
	}
	
	final void setLock(InterProcessMutex lock)
	{
		this.lock = lock;
	}

	public final InterProcessMutex getLock()
	{
		return lock;
	}
	
	final long getTime()
	{
		return this.time;
	}
	
	final void setTime(long time)
	{
		this.time = time;
	}
	
	public abstract String getKey();
	
	public abstract void parseKey(String key);
	
	public abstract boolean free(K obj, V key);
}
