package remote;

import java.util.concurrent.TimeUnit;

import org.apache.curator.framework.CuratorFramework;
import org.apache.curator.framework.recipes.locks.InterProcessMutex;
import org.apache.zookeeper.KeeperException;

public class LockMap implements LockManager {

	private CuratorFramework client;
	String base;
	public LockMap(String basePath, CuratorFramework client) throws Exception
	{ 
		this.client = client;
		try
		{
			client.create().creatingParentsIfNeeded().forPath(basePath);
		}
		catch(KeeperException.NodeExistsException e){}
		base = basePath + "/";
		
	}
	@Override
	public InterProcessMutex getLock(String key) throws Exception {
		InterProcessMutex m = new InterProcessMutex(client, base+key);
		
		while(!m.acquire(25,TimeUnit.SECONDS))
		{
			System.out.println(key + " LOCK");
		}
		return m;
	}

	@Override
	public InterProcessMutex tryLock(String key) throws Exception {
		InterProcessMutex m = new InterProcessMutex(client, base+key);
		if(m.acquire(0,TimeUnit.MILLISECONDS)) return m;
		return null;
	}

	@Override
	public void releaseLock(InterProcessMutex lock) throws Exception {
		lock.release();
	}

}
