package repository;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.nio.file.FileSystems;
import java.nio.file.Files;
import java.nio.file.Path;
import java.util.Iterator;

public class FileRepository extends Repository {

	String path;
	public FileRepository(String basePath)
	{
		path = basePath;
		deleteDirectory(new File(basePath));
		new File(basePath).mkdir();
	}
	
	@Override
	public boolean put(String key, String Bucket, InputStream data, int s) throws Exception {
		FileOutputStream os = new FileOutputStream(path + "/" + key);
		byte[] buffer = new byte[4096];
		int size;
		while( (size = data.read(buffer)) > 0)
		{
			os.write(buffer, 0, size);
		}
		
		Thread.sleep(100);
		os.close();
	
		return true;
	}

	public static boolean deleteDirectory(File directory) {
	    if(directory.exists()){
	        File[] files = directory.listFiles();
	        if(null!=files){
	            for(int i=0; i<files.length; i++) {
	                if(files[i].isDirectory()) {
	                    deleteDirectory(files[i]);
	                }
	                else {
	                    files[i].delete();
	                }
	            }
	        }
	    }
	    return(directory.delete());
	}

	@Override
	public DataReader get(String key, String Bucket) throws FileNotFoundException {
		File f = new File(path + "/" + key);
		int size = (int) f.length();
		return new DataReader(new FileInputStream(path + "/" + key),size);
	}

	@Override
	public boolean remove(String key, String bucket) throws IOException {
		Path p = FileSystems.getDefault().getPath(path, key);
		return Files.deleteIfExists(p);
	}

	@Override
	public Iterator<String> getKeys(String bucket) {
		// TODO Auto-generated method stub
		return null;
	}
}
