package repository;

import java.io.InputStream;
import java.util.Iterator;

import com.amazonaws.auth.BasicAWSCredentials;
import com.amazonaws.services.s3.AmazonS3;
import com.amazonaws.services.s3.AmazonS3Client;
import com.amazonaws.services.s3.model.GetObjectRequest;
import com.amazonaws.services.s3.model.ObjectMetadata;
import com.amazonaws.services.s3.model.PutObjectRequest;
import com.amazonaws.services.s3.model.S3Object;

public class S3Repository extends Repository {

	String secret = "";
	String access = "";
	String prefix;
	AmazonS3 s3;
	
	public S3Repository(String prefix)
	{
		this.prefix = prefix;
		s3 = new AmazonS3Client(new BasicAWSCredentials(access,secret));
		
	}

	@Override
	public boolean put(String key, String bucket, InputStream data, int size)
			throws Exception {
		bucket = prefix + bucket;
		ObjectMetadata obj = new ObjectMetadata();
		obj.setContentLength(size);
		s3.putObject(new PutObjectRequest(bucket, key, data,obj));
		return true;
	}

	@Override
	public DataReader get(String key, String bucket) throws Exception {
			bucket = prefix + bucket;
			S3Object object = s3.getObject(new GetObjectRequest(bucket, key));
			return new DataReader(object.getObjectContent(),
					(int) object.getObjectMetadata().getContentLength());
	}

	@Override
	public boolean remove(String key, String bucket) throws Exception {
			bucket = prefix + bucket;
			s3.deleteObject(bucket, key);
			return true;
	}

	@Override
	public Iterator<String> getKeys(String bucket) throws Exception {
		// TODO Auto-generated method stub
		return null;
	}

}
